Index: hardware/pic_conso.sch
===================================================================
--- hardware/pic_conso.sch	(revision 1)
+++ hardware/pic_conso.sch	(revision 2)
@@ -1,3 +1,4 @@
 EESchema Schematic File Version 2
+LIBS:pic_conso-rescue
 LIBS:microchip-local
 LIBS:power
@@ -104,5 +105,5 @@
 $EndComp
 $Comp
-L USB_B P6
+L USB_B-RESCUE-pic_conso P6
 U 1 1 585D351B
 P 8450 4350
@@ -247,5 +248,5 @@
 $EndComp
 $Comp
-L AD623 U1
+L AD623-RESCUE-pic_conso U1
 U 1 1 585D5B75
 P 3000 2700
@@ -269,12 +270,12 @@
 $EndComp
 $Comp
-L CONN_02X03 J2
+L Conn_02x04_Odd_Even J2
 U 1 1 585D63A9
-P 2400 2950
-F 0 "J2" H 2400 3150 50  0000 C CNN
-F 1 "CONN_02X03" H 2400 2750 50  0000 C CNN
-F 2 "Pin_Headers:Pin_Header_Straight_2x03" H 2400 1750 50  0001 C CNN
-F 3 "" H 2400 1750 50  0000 C CNN
-	1    2400 2950
+P 2300 3000
+F 0 "J2" H 2300 3200 50  0000 C CNN
+F 1 "CONN_02X04" H 2300 2800 50  0000 C CNN
+F 2 "Pin_Headers:Pin_Header_Straight_2x04_Pitch2.54mm" H 2300 1800 50  0001 C CNN
+F 3 "" H 2300 1800 50  0000 C CNN
+	1    2300 3000
 	0    -1   -1   0   
 $EndComp
@@ -318,5 +319,5 @@
 F 0 "R4" V 2250 2300 50  0000 L CNN
 F 1 "0.05" V 2350 2550 50  0000 L CNN
-F 2 "Resistors_ThroughHole:Resistor_Horizontal_RM25mm" H 2300 2450 50  0001 C CNN
+F 2 "Resistors_THT:R_Axial_Power_L25.0mm_W6.4mm_P30.48mm" H 2300 2450 50  0001 C CNN
 F 3 "" H 2300 2450 50  0000 C CNN
 	1    2300 2450
@@ -329,5 +330,5 @@
 F 0 "P2" H 1750 2900 50  0000 C CNN
 F 1 "CONN_01X03" V 1850 2700 50  0000 C CNN
-F 2 "Terminal_Blocks:TerminalBlock_Pheonix_MPT-2.54mm_3pol" H 1750 2700 50  0001 C CNN
+F 2 "Connectors_Phoenix:PhoenixContact_MSTBVA-G_03x5.00mm_Vertical" H 1750 2700 50  0001 C CNN
 F 3 "" H 1750 2700 50  0000 C CNN
 	1    1750 2700
@@ -335,5 +336,5 @@
 $EndComp
 $Comp
-L USB_A P1
+L USB_A-RESCUE-pic_conso P1
 U 1 1 585D7EE0
 P 1150 2700
@@ -461,5 +462,5 @@
 F 0 "R5" V 2350 2300 50  0000 L CNN
 F 1 "0.1" V 2450 2550 50  0000 L CNN
-F 2 "Resistors_ThroughHole:Resistor_Horizontal_RM25mm" H 2400 2450 50  0001 C CNN
+F 2 "Resistors_THT:R_Axial_Power_L25.0mm_W6.4mm_P30.48mm" H 2400 2450 50  0001 C CNN
 F 3 "" H 2400 2450 50  0000 C CNN
 	1    2400 2450
@@ -472,5 +473,5 @@
 F 0 "R6" V 2450 2300 50  0000 L CNN
 F 1 "0.2" V 2550 2550 50  0000 L CNN
-F 2 "Resistors_ThroughHole:Resistor_Horizontal_RM25mm" H 2500 2450 50  0001 C CNN
+F 2 "Resistors_THT:R_Axial_Power_L25.0mm_W6.4mm_P30.48mm" H 2500 2450 50  0001 C CNN
 F 3 "" H 2500 2450 50  0000 C CNN
 	1    2500 2450
@@ -573,5 +574,5 @@
 F 0 "R11" V 4350 3500 50  0000 L CNN
 F 1 "1k" V 4300 3700 50  0000 L CNN
-F 2 "Resistors_ThroughHole:Resistor_Horizontal_RM10mm" H 4250 3600 50  0001 C CNN
+F 2 "Resistors_THT:R_Axial_DIN0411_L9.9mm_D3.6mm_P12.70mm_Horizontal" H 4250 3600 50  0001 C CNN
 F 3 "" H 4250 3600 50  0000 C CNN
 	1    4250 3600
@@ -595,5 +596,5 @@
 F 0 "R10" V 4150 3500 50  0000 L CNN
 F 1 "1k" V 4100 3700 50  0000 L CNN
-F 2 "Resistors_ThroughHole:Resistor_Horizontal_RM10mm" H 4050 3600 50  0001 C CNN
+F 2 "Resistors_THT:R_Axial_DIN0411_L9.9mm_D3.6mm_P15.24mm_Horizontal" H 4050 3600 50  0001 C CNN
 F 3 "" H 4050 3600 50  0000 C CNN
 	1    4050 3600
@@ -618,7 +619,7 @@
 	1950 2800 1950 3300
 Wire Wire Line
-	2150 2600 2150 2300
-Wire Wire Line
-	1450 2600 2150 2600
+	2050 2600 2050 2300
+Wire Wire Line
+	1450 2600 2050 2600
 Connection ~ 2500 3300
 Wire Wire Line
@@ -626,9 +627,7 @@
 Connection ~ 2500 2300
 Wire Wire Line
-	2700 2300 2700 2600
-Wire Wire Line
 	2900 3000 2900 3100
 Wire Wire Line
-	2150 2300 2700 2300
+	2050 2300 2700 2300
 Connection ~ 2300 3300
 Wire Wire Line
@@ -1126,3 +1125,41 @@
 	6700 3350 8150 3350
 Connection ~ 8150 3900
+$Comp
+L R_Small R22
+U 1 1 5CDAAD6A
+P 2200 2450
+F 0 "R22" V 2150 2300 50  0000 L CNN
+F 1 "0.02" V 2250 2550 50  0000 L CNN
+F 2 "Resistors_THT:R_Axial_Power_L25.0mm_W6.4mm_P30.48mm" H 2200 2450 50  0001 C CNN
+F 3 "" H 2200 2450 50  0000 C CNN
+	1    2200 2450
+	-1   0    0    1   
+$EndComp
+Wire Wire Line
+	2200 2350 2200 2300
+Connection ~ 2200 2300
+Wire Wire Line
+	2200 2550 2200 2700
+Wire Wire Line
+	2200 3200 2200 3300
+Connection ~ 2200 3300
+Text Label 2150 2300 0    60   ~ 0
+GNDO
+Text Label 1550 2350 0    60   ~ 0
+VCCO
+$Comp
+L R_Small R23
+U 1 1 5CDBEBA9
+P 2700 2450
+F 0 "R23" V 2650 2300 50  0000 L CNN
+F 1 "10k" V 2750 2550 50  0000 L CNN
+F 2 "Resistors_Universal:Resistor_SMDuniversal_0805to1206_HandSoldering" H 2700 2450 50  0001 C CNN
+F 3 "" H 2700 2450 50  0000 C CNN
+	1    2700 2450
+	-1   0    0    1   
+$EndComp
+Wire Wire Line
+	2700 2600 2700 2550
+Wire Wire Line
+	2700 2300 2700 2350
 $EndSCHEMATC