Index: branches/with_autoconf/src/schedulers.cc
===================================================================
--- branches/with_autoconf/src/schedulers.cc	(revision 7)
+++ branches/with_autoconf/src/schedulers.cc	(revision 8)
@@ -35,15 +35,18 @@
  */
 
-#include<iostream>
-#include"sc_module.h" // method_process_t
-#include"gen_code.h"  // gen_scheduling_code_for_dynamic_link & gen_scheduling_code_for_static_func
-#include"internal.h"  // dump_all_graph
-#include"graph_cass.h" // makegraph
-#include"process_dependency.h" // MakeProcessDependencyList
-#include"signal_dependency.h" // MakeSignalDependencyGraph
-#include"mouchard_scheduling.h" // MakeMouchardScheduling
-#include"graph_signals.h" // makegraph
-//#include"module_hierarchy2dot.h"
-#include"assert.h"
+#include <iostream>
+#include "sc_module.h" // method_process_t
+#include "gen_code.h"  // gen_scheduling_code_for_dynamic_link & gen_scheduling_code_for_static_func
+#include "internal.h"  // dump_all_graph
+#include "graph_cass.h" // makegraph
+#include "process_dependency.h" // MakeProcessDependencyList
+#include "signal_dependency.h" // MakeSignalDependencyGraph
+#include "mouchard_scheduling.h" // MakeMouchardScheduling
+#include "graph_signals.h" // makegraph
+//#include "module_hierarchy2dot.h"
+#include <cassert>
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 using namespace std;
@@ -94,6 +97,6 @@
                          const method_process_t *a2)
 {
-  ASSERT(a1 != NULL);
-  ASSERT(a2 != NULL);
+  assert(a1 != NULL);
+  assert(a2 != NULL);
   sc_module *m1 = a1->module;
   sc_module *m2 = a2->module;
@@ -113,5 +116,5 @@
     addr1.func = a1->func;
     addr2.func = a2->func;
-    ASSERT(addr1.addr_ll != addr2.addr_ll);
+    assert(addr1.addr_ll != addr2.addr_ll);
     if ( sizeof(SC_ENTRY_FUNC) == 4 ) {
         return (addr1.addr_l < addr2.addr_l);
@@ -129,6 +132,6 @@
                     const method_process_t *a2)
 {
-  ASSERT(a1 != NULL);
-  ASSERT(a2 != NULL);
+  assert(a1 != NULL);
+  assert(a2 != NULL);
   return (a1->module < a2->module);
 }
@@ -139,6 +142,6 @@
                  const method_process_t *a2)
 {
-    ASSERT(a1 != NULL);
-    ASSERT(a2 != NULL);
+    assert(a1 != NULL);
+    assert(a2 != NULL);
     union {
         SC_ENTRY_FUNC func;
@@ -236,8 +239,8 @@
 {
   SignalDependencyGraph *sig_graph = MakeAcyclicSignalDependencyGraph ();
-  ASSERT(sig_graph != NULL);
+  assert(sig_graph != NULL);
   // Create the process evaluation list
   ProcessDependencyList* process_list = MakeMouchardScheduling (*sig_graph);
-  ASSERT(process_list != NULL);
+  assert(process_list != NULL);
 
   if (dump_all_graph)
@@ -283,6 +286,8 @@
     // Uses port dependancies like Dr. Mouchard.
     ProcessDependencyList* process_list = BuchmannScheduling ();
-    base_name = gen_scheduling_code_for_dynamic_link (transition_func_list, moore_func_list,*process_list);
-    gen_scheduling_code_for_static_func (transition_func_list, moore_func_list, *process_list);
+	if (dynamic_link_of_scheduling_code)
+		base_name = gen_scheduling_code_for_dynamic_link (transition_func_list, moore_func_list,*process_list);
+	else
+		gen_scheduling_code_for_static_func (transition_func_list, moore_func_list, *process_list);
     break;
   }
@@ -294,6 +299,8 @@
     // and does not use an event-driven scheduler.
     ProcessDependencyList* process_list = MouchardScheduling ();
-    base_name = gen_scheduling_code_for_dynamic_link(transition_func_list, moore_func_list,*process_list);
-    gen_scheduling_code_for_static_func (transition_func_list, moore_func_list, *process_list);
+	if (dynamic_link_of_scheduling_code)
+		base_name = gen_scheduling_code_for_dynamic_link(transition_func_list, moore_func_list,*process_list);
+	else
+		gen_scheduling_code_for_static_func (transition_func_list, moore_func_list, *process_list);
     break;
   }
@@ -306,6 +313,8 @@
       graph2dot("module_graph", *g);
     strong_component_list_t *strong_list = strong_component (g);
-    base_name = gen_scheduling_code_for_dynamic_link(transition_func_list, moore_func_list,*strong_list);
-    gen_scheduling_code_for_quasistatic_func (transition_func_list, moore_func_list, *strong_list);
+	if (dynamic_link_of_scheduling_code)
+		base_name = gen_scheduling_code_for_dynamic_link(transition_func_list, moore_func_list,*strong_list);
+	else
+		gen_scheduling_code_for_quasistatic_func (transition_func_list, moore_func_list, *strong_list);
     break;
   }