Index: trunk/hardware/pic_conso-cache.lib
===================================================================
--- trunk/hardware/pic_conso-cache.lib	(revision 8)
+++ trunk/hardware/pic_conso-cache.lib	(revision 9)
@@ -15,19 +15,4 @@
 P 2 0 1 0 0 100 30 50 N
 X +3V3 1 0 0 0 U 50 50 1 1 W N
-ENDDRAW
-ENDDEF
-#
-# +5V
-#
-DEF +5V #PWR 0 0 Y Y 1 F P
-F0 "#PWR" 0 -150 50 H I C CNN
-F1 "+5V" 0 140 50 H V C CNN
-F2 "" 0 0 50 H I C CNN
-F3 "" 0 0 50 H I C CNN
-DRAW
-P 2 0 1 0 -30 50 0 100 N
-P 2 0 1 0 0 0 0 100 N
-P 2 0 1 0 0 100 30 50 N
-X +5V 1 0 0 0 U 50 50 1 1 W N
 ENDDRAW
 ENDDEF
@@ -79,28 +64,4 @@
 X P1 1 -200 50 150 R 50 50 1 1 P
 X P2 2 -200 -50 150 R 50 50 1 1 P
-ENDDRAW
-ENDDEF
-#
-# CONN_01X03
-#
-DEF CONN_01X03 P 0 40 Y N 1 F N
-F0 "P" 0 200 50 H V C CNN
-F1 "CONN_01X03" 100 0 50 V V C CNN
-F2 "" 0 0 50 H V C CNN
-F3 "" 0 0 50 H V C CNN
-$FPLIST
- Pin_Header_Straight_1X03
- Pin_Header_Angled_1X03
- Socket_Strip_Straight_1X03
- Socket_Strip_Angled_1X03
-$ENDFPLIST
-DRAW
-S -50 -95 10 -105 0 1 0 N
-S -50 5 10 -5 0 1 0 N
-S -50 105 10 95 0 1 0 N
-S -50 150 50 -150 0 1 0 N
-X P1 1 -200 100 150 R 50 50 1 1 P
-X P2 2 -200 0 150 R 50 50 1 1 P
-X P3 3 -200 -100 150 R 50 50 1 1 P
 ENDDRAW
 ENDDEF
@@ -200,4 +161,70 @@
 ENDDEF
 #
+# Conn_01x05
+#
+DEF Conn_01x05 J 0 40 Y N 1 F N
+F0 "J" 0 300 50 H V C CNN
+F1 "Conn_01x05" 0 -300 50 H V C CNN
+F2 "" 0 0 50 H I C CNN
+F3 "" 0 0 50 H I C CNN
+$FPLIST
+ Connector*:*_??x*mm*
+ Connector*:*1x??x*mm*
+ Pin?Header?Straight?1X*
+ Pin?Header?Angled?1X*
+ Socket?Strip?Straight?1X*
+ Socket?Strip?Angled?1X*
+$ENDFPLIST
+DRAW
+S -50 -195 0 -205 1 1 6 N
+S -50 -95 0 -105 1 1 6 N
+S -50 5 0 -5 1 1 6 N
+S -50 105 0 95 1 1 6 N
+S -50 205 0 195 1 1 6 N
+S -50 250 50 -250 1 1 10 f
+X Pin_1 1 -200 200 150 R 50 50 1 1 P
+X Pin_2 2 -200 100 150 R 50 50 1 1 P
+X Pin_3 3 -200 0 150 R 50 50 1 1 P
+X Pin_4 4 -200 -100 150 R 50 50 1 1 P
+X Pin_5 5 -200 -200 150 R 50 50 1 1 P
+ENDDRAW
+ENDDEF
+#
+# Conn_01x08
+#
+DEF Conn_01x08 J 0 40 Y N 1 F N
+F0 "J" 0 400 50 H V C CNN
+F1 "Conn_01x08" 0 -500 50 H V C CNN
+F2 "" 0 0 50 H I C CNN
+F3 "" 0 0 50 H I C CNN
+$FPLIST
+ Connector*:*_??x*mm*
+ Connector*:*1x??x*mm*
+ Pin?Header?Straight?1X*
+ Pin?Header?Angled?1X*
+ Socket?Strip?Straight?1X*
+ Socket?Strip?Angled?1X*
+$ENDFPLIST
+DRAW
+S -50 -395 0 -405 1 1 6 N
+S -50 -295 0 -305 1 1 6 N
+S -50 -195 0 -205 1 1 6 N
+S -50 -95 0 -105 1 1 6 N
+S -50 5 0 -5 1 1 6 N
+S -50 105 0 95 1 1 6 N
+S -50 205 0 195 1 1 6 N
+S -50 305 0 295 1 1 6 N
+S -50 350 50 -450 1 1 10 f
+X Pin_1 1 -200 300 150 R 50 50 1 1 P
+X Pin_2 2 -200 200 150 R 50 50 1 1 P
+X Pin_3 3 -200 100 150 R 50 50 1 1 P
+X Pin_4 4 -200 0 150 R 50 50 1 1 P
+X Pin_5 5 -200 -100 150 R 50 50 1 1 P
+X Pin_6 6 -200 -200 150 R 50 50 1 1 P
+X Pin_7 7 -200 -300 150 R 50 50 1 1 P
+X Pin_8 8 -200 -400 150 R 50 50 1 1 P
+ENDDRAW
+ENDDEF
+#
 # Conn_02x01
 #
@@ -276,4 +303,27 @@
 ENDDEF
 #
+# D_Zener_Small
+#
+DEF D_Zener_Small D 0 10 N N 1 F N
+F0 "D" 0 90 50 H V C CNN
+F1 "D_Zener_Small" 0 -90 50 H V C CNN
+F2 "" 0 0 50 V I C CNN
+F3 "" 0 0 50 V I C CNN
+$FPLIST
+ TO-???*
+ *SingleDiode
+ *_Diode_*
+ *SingleDiode*
+ D_*
+$ENDFPLIST
+DRAW
+P 2 0 1 0 30 0 -30 0 N
+P 3 0 1 0 -10 40 -30 40 -30 -40 N
+P 4 0 1 0 30 40 -30 0 30 -40 30 40 N
+X K 1 -100 0 70 R 50 50 1 1 P
+X A 2 100 0 70 L 50 50 1 1 P
+ENDDRAW
+ENDDEF
+#
 # GND
 #
@@ -299,4 +349,18 @@
 P 6 0 1 0 0 0 0 -50 50 -50 0 -100 -50 -50 0 -50 N
 X GNDA 1 0 0 0 D 50 50 1 1 W N
+ENDDRAW
+ENDDEF
+#
+# GNDD
+#
+DEF GNDD #PWR 0 0 Y Y 1 F P
+F0 "#PWR" 0 -250 50 H I C CNN
+F1 "GNDD" 0 -125 50 H V C CNN
+F2 "" 0 0 50 H I C CNN
+F3 "" 0 0 50 H I C CNN
+DRAW
+S -50 -60 50 -80 0 1 10 F
+P 2 0 1 0 0 0 0 -60 N
+X GNDD 1 0 0 0 D 50 50 1 1 W N
 ENDDRAW
 ENDDEF
@@ -431,4 +495,35 @@
 ENDDEF
 #
+# Q_NMOS_GSD
+#
+DEF Q_NMOS_GSD Q 0 0 Y N 1 F N
+F0 "Q" 200 50 50 H V L CNN
+F1 "Q_NMOS_GSD" 200 -50 50 H V L CNN
+F2 "" 200 100 50 H I C CNN
+F3 "" 0 0 50 H I C CNN
+DRAW
+C 65 0 111 0 1 10 N
+C 100 -70 11 0 1 0 F
+C 100 70 11 0 1 0 F
+P 2 0 1 0 30 -70 100 -70 N
+P 2 0 1 10 30 -50 30 -90 N
+P 2 0 1 0 30 0 100 0 N
+P 2 0 1 10 30 20 30 -20 N
+P 2 0 1 0 30 70 100 70 N
+P 2 0 1 10 30 90 30 50 N
+P 2 0 1 0 100 -70 100 -100 N
+P 2 0 1 0 100 -70 100 0 N
+P 2 0 1 0 100 100 100 70 N
+P 3 0 1 10 10 75 10 -75 10 -75 N
+P 4 0 1 0 40 0 80 15 80 -15 40 0 F
+P 4 0 1 0 100 -70 130 -70 130 70 100 70 N
+P 4 0 1 0 110 20 115 15 145 15 150 10 N
+P 4 0 1 0 130 15 115 -10 145 -10 130 15 N
+X G 1 -200 0 210 R 50 50 1 1 I
+X S 2 100 -200 100 U 50 50 1 1 P
+X D 3 100 200 100 D 50 50 1 1 P
+ENDDRAW
+ENDDEF
+#
 # R_Small
 #
@@ -445,4 +540,77 @@
 X ~ 1 0 100 30 D 50 50 1 1 P
 X ~ 2 0 -100 30 U 50 50 1 1 P
+ENDDRAW
+ENDDEF
+#
+# Si4483
+#
+DEF Si4483 Q 0 0 Y N 1 F N
+F0 "Q" 200 50 50 H V L CNN
+F1 "Si4483" 200 -50 50 H V L CNN
+F2 "" 200 100 50 H I C CNN
+F3 "" 0 0 50 H I C CNN
+DRAW
+C 65 0 111 0 1 10 N
+C 100 -70 11 0 1 0 F
+C 100 70 11 0 1 0 F
+P 2 0 1 0 30 -70 100 -70 N
+P 2 0 1 10 30 -50 30 -90 N
+P 2 0 1 0 30 0 100 0 N
+P 2 0 1 10 30 20 30 -20 N
+P 2 0 1 0 30 70 100 70 N
+P 2 0 1 10 30 90 30 50 N
+P 2 0 1 0 100 -100 300 -100 N
+P 2 0 1 0 100 -70 100 -100 N
+P 2 0 1 0 100 -70 100 0 N
+P 2 0 1 0 100 100 100 70 N
+P 2 0 1 0 200 100 100 100 N
+P 3 0 1 10 10 75 10 -75 10 -75 N
+P 3 0 1 0 200 100 300 100 400 100 N
+P 4 0 1 0 90 0 50 -15 50 15 90 0 F
+P 4 0 1 0 100 -70 130 -70 130 70 100 70 N
+P 4 0 1 0 110 -20 115 -15 145 -15 150 -10 N
+P 4 0 1 0 130 -15 115 10 145 10 130 -15 N
+X S 1 100 -200 100 U 50 50 1 1 P
+X S 2 200 -200 100 U 50 50 1 1 P
+X S 3 300 -200 100 U 50 50 1 1 P
+X G 4 -200 0 210 R 50 50 1 1 I
+X D 5 100 200 100 D 50 50 1 1 P
+X D 6 200 200 100 D 50 50 1 1 P
+X D 7 300 200 100 D 50 50 1 1 P
+X D 8 400 200 100 D 50 50 1 1 P
+ENDDRAW
+ENDDEF
+#
+# TLP2358
+#
+DEF TLP2358 U 0 40 Y Y 1 F N
+F0 "U" -200 200 50 H V L CNN
+F1 "TLP2358" 0 200 50 H V L CNN
+F2 "Housings_SOIC:SO-6_4.4x3.6mm_Pitch1.27mm" -200 -200 50 H I L CIN
+F3 "" 0 0 50 H I L CNN
+ALIAS 4N26 TIL111 4N27 4N28
+$FPLIST
+ DIP*W7.62mm*
+$ENDFPLIST
+DRAW
+S -200 150 200 -150 0 1 10 f
+P 2 0 1 10 -150 -25 -100 -25 N
+P 2 0 1 0 105 -55 150 -100 N
+P 2 0 1 0 105 -45 150 0 N
+P 2 0 1 0 150 -100 200 -100 N
+P 2 0 1 0 150 0 200 0 N
+P 3 0 1 14 105 -10 105 -90 105 -90 N
+P 4 0 1 0 -200 -100 -125 -100 -125 100 -200 100 N
+P 4 0 1 10 -125 -25 -150 25 -100 25 -125 -25 F
+P 4 0 1 0 145 -95 135 -75 125 -85 145 -95 N
+P 4 0 1 0 200 100 75 100 75 -50 100 -50 N
+P 5 0 1 0 -25 -20 25 -20 10 -25 10 -15 25 -20 N
+P 5 0 1 0 -25 20 25 20 10 15 10 25 25 20 N
+X ~ 1 -300 100 100 R 50 50 1 1 P
+X NC 2 -300 0 100 R 50 50 1 1 N N
+X ~ 3 -300 -100 100 R 50 50 1 1 P
+X ~ 4 300 -100 100 L 50 50 1 1 P
+X ~ 5 300 0 100 L 50 50 1 1 P
+X ~ 6 300 100 100 L 50 50 1 1 P
 ENDDRAW
 ENDDEF
@@ -496,3 +664,89 @@
 ENDDEF
 #
+# VO1400AEFTR
+#
+DEF VO1400AEFTR U 0 40 Y N 1 L N
+F0 "U" -200 320 50 H V L BNN
+F1 "VO1400AEFTR" -200 -400 50 H V L BNN
+F2 "SOIC254P695X242-4N" 0 0 50 H I L BNN
+F3 "SOP-4 Vishay" 0 0 50 H I L BNN
+F4 "Vishay" 0 0 50 H I L BNN
+F5 "Unavailable" 0 0 50 H I L BNN
+F6 "VO1400AEFTR" 0 0 50 H I L BNN
+F7 "None" 0 0 50 H I L BNN
+F8 "VO1400 Series SPST 60 V 100 mA 5 Ohm 1 Form A Solid State Relay - SOIC-4" 0 0 50 H I L BNN
+DRAW
+T 0 -290 200 60 0 0 0 A Normal 0 L B
+T 0 -291 -200 60 0 0 0 C Normal 0 L B
+T 0 441 120 60 0 0 0 S1 Normal 0 L B
+T 0 440 -170 60 0 0 0 S2 Normal 0 L B
+P 2 0 0 16 -400 -300 400 -300 N
+P 2 0 0 16 -400 -200 -400 -300 N
+P 2 0 0 10 -400 -200 -300 -200 N
+P 2 0 0 16 -400 200 -400 -200 N
+P 2 0 0 10 -400 200 -300 200 N
+P 2 0 0 16 -400 300 -400 200 N
+P 2 0 0 16 -400 300 400 300 N
+P 2 0 0 10 -300 -200 -300 -50 N
+P 2 0 0 10 -300 -50 -350 -50 N
+P 2 0 0 10 -300 -50 -350 50 N
+P 2 0 0 6 -300 40 -300 -50 N
+P 2 0 0 10 -300 50 -350 50 N
+P 2 0 0 6 -300 50 -300 40 N
+P 2 0 0 10 -300 200 -300 40 N
+P 2 0 0 10 -250 -50 -300 -50 N
+P 2 0 0 10 -250 50 -300 -50 N
+P 2 0 0 10 -250 50 -300 50 N
+P 2 0 0 10 -180 -60 -140 -70 N
+P 2 0 0 10 -170 -40 -180 -60 N
+P 2 0 0 10 -160 -60 -250 -20 N
+P 2 0 0 10 -160 -20 -120 -30 N
+P 2 0 0 10 -150 0 -160 -20 N
+P 2 0 0 10 -140 -70 -170 -40 N
+P 2 0 0 10 -140 -20 -230 20 N
+P 2 0 0 10 -120 -30 -150 0 N
+P 2 0 0 10 0 -130 0 140 N
+P 2 0 0 10 0 140 100 140 N
+P 2 0 0 10 100 -210 100 -130 N
+P 2 0 0 10 100 -130 0 -130 N
+P 2 0 0 10 100 -130 100 -50 N
+P 2 0 0 10 100 50 100 140 N
+P 2 0 0 10 100 140 100 210 N
+P 2 0 0 10 140 -230 140 -180 N
+P 2 0 0 10 140 -160 140 -110 N
+P 2 0 0 10 140 -90 140 -60 N
+P 2 0 0 10 140 -60 140 -40 N
+P 2 0 0 10 140 -60 230 -60 N
+P 2 0 0 10 140 30 140 60 N
+P 2 0 0 10 140 60 140 80 N
+P 2 0 0 10 140 60 230 60 N
+P 2 0 0 10 140 100 140 130 N
+P 2 0 0 10 140 130 140 150 N
+P 2 0 0 10 140 130 230 130 N
+P 2 0 0 10 140 170 140 220 N
+P 2 0 0 10 150 -130 170 -130 N
+P 2 0 0 10 150 200 400 200 N
+P 2 0 0 10 160 130 210 120 N
+P 2 0 0 10 170 -130 210 -140 N
+P 2 0 0 10 170 -130 230 -130 N
+P 2 0 0 10 210 -140 210 -120 N
+P 2 0 0 10 210 -120 170 -130 N
+P 2 0 0 10 210 120 210 140 N
+P 2 0 0 10 210 140 160 130 N
+P 2 0 0 10 230 -130 230 -60 N
+P 2 0 0 10 230 -60 300 -60 N
+P 2 0 0 10 230 60 300 60 N
+P 2 0 0 10 230 130 230 60 N
+P 2 0 0 10 300 60 300 -60 N
+P 2 0 0 10 400 -200 150 -200 N
+P 2 0 0 16 400 -200 400 -300 N
+P 2 0 0 16 400 200 400 -200 N
+P 2 0 0 16 400 300 400 200 N
+X A 1 -600 200 200 R 40 40 0 0 P
+X C 2 -600 -200 200 R 40 40 0 0 P
+X S2 3 600 -200 200 L 40 40 0 0 P
+X S1 4 600 200 200 L 40 40 0 0 P
+ENDDRAW
+ENDDEF
+#
 #End Library