Index: trunk/hardware/pic_conso-cache.lib
===================================================================
--- trunk/hardware/pic_conso-cache.lib	(revision 9)
+++ trunk/hardware/pic_conso-cache.lib	(revision 10)
@@ -1,13 +1,12 @@
-EESchema-LIBRARY Version 2.3
+EESchema-LIBRARY Version 2.4
 #encoding utf-8
 #
-# +3V3
-#
-DEF +3V3 #PWR 0 0 Y Y 1 F P
+# pic_conso-rescue_+3.3V
+#
+DEF pic_conso-rescue_+3.3V #PWR 0 0 Y Y 1 F P
 F0 "#PWR" 0 -150 50 H I C CNN
-F1 "+3V3" 0 140 50 H V C CNN
-F2 "" 0 0 50 H I C CNN
-F3 "" 0 0 50 H I C CNN
-ALIAS +3.3V
+F1 "pic_conso-rescue_+3.3V" 0 140 50 H V C CNN
+F2 "" 0 0 50 H I C CNN
+F3 "" 0 0 50 H I C CNN
 DRAW
 P 2 0 1 0 -30 50 0 100 N
@@ -18,9 +17,9 @@
 ENDDEF
 #
-# AD623-RESCUE-pic_conso
-#
-DEF AD623-RESCUE-pic_conso U 0 20 Y Y 1 F N
+# pic_conso-rescue_AD623-RESCUE-pic_conso
+#
+DEF pic_conso-rescue_AD623-RESCUE-pic_conso U 0 20 Y Y 1 F N
 F0 "U" 200 150 50 H V L CNN
-F1 "AD623-RESCUE-pic_conso" 200 -150 50 H V L CNN
+F1 "pic_conso-rescue_AD623-RESCUE-pic_conso" 200 -150 50 H V L CNN
 F2 "" 0 0 50 H V C CNN
 F3 "" 0 0 50 H V C CNN
@@ -45,9 +44,9 @@
 ENDDEF
 #
-# CONN_01X02
-#
-DEF CONN_01X02 P 0 40 Y N 1 F N
+# pic_conso-rescue_CONN_01X02
+#
+DEF pic_conso-rescue_CONN_01X02 P 0 40 Y N 1 F N
 F0 "P" 0 150 50 H V C CNN
-F1 "CONN_01X02" 100 0 50 V V C CNN
+F1 "pic_conso-rescue_CONN_01X02" 100 0 50 V V C CNN
 F2 "" 0 0 50 H V C CNN
 F3 "" 0 0 50 H V C CNN
@@ -67,9 +66,9 @@
 ENDDEF
 #
-# CONN_01X04
-#
-DEF CONN_01X04 P 0 40 Y N 1 F N
+# pic_conso-rescue_CONN_01X04
+#
+DEF pic_conso-rescue_CONN_01X04 P 0 40 Y N 1 F N
 F0 "P" 0 250 50 H V C CNN
-F1 "CONN_01X04" 100 0 50 V V C CNN
+F1 "pic_conso-rescue_CONN_01X04" 100 0 50 V V C CNN
 F2 "" 0 0 50 H V C CNN
 F3 "" 0 0 50 H V C CNN
@@ -93,9 +92,9 @@
 ENDDEF
 #
-# CONN_02X03
-#
-DEF CONN_02X03 P 0 1 Y N 1 F N
+# pic_conso-rescue_CONN_02X03
+#
+DEF pic_conso-rescue_CONN_02X03 P 0 1 Y N 1 F N
 F0 "P" 0 200 50 H V C CNN
-F1 "CONN_02X03" 0 -200 50 H V C CNN
+F1 "pic_conso-rescue_CONN_02X03" 0 -200 50 H V C CNN
 F2 "" 0 -1200 50 H V C CNN
 F3 "" 0 -1200 50 H V C CNN
@@ -123,9 +122,9 @@
 ENDDEF
 #
-# CP_Small
-#
-DEF CP_Small C 0 10 N N 1 F N
+# pic_conso-rescue_CP_Small
+#
+DEF pic_conso-rescue_CP_Small C 0 10 N N 1 F N
 F0 "C" 10 70 50 H V L CNN
-F1 "CP_Small" 10 -80 50 H V L CNN
+F1 "pic_conso-rescue_CP_Small" 10 -80 50 H V L CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -143,9 +142,9 @@
 ENDDEF
 #
-# C_Small
-#
-DEF C_Small C 0 10 N N 1 F N
+# pic_conso-rescue_C_Small
+#
+DEF pic_conso-rescue_C_Small C 0 10 N N 1 F N
 F0 "C" 10 70 50 H V L CNN
-F1 "C_Small" 10 -80 50 H V L CNN
+F1 "pic_conso-rescue_C_Small" 10 -80 50 H V L CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -161,9 +160,9 @@
 ENDDEF
 #
-# Conn_01x05
-#
-DEF Conn_01x05 J 0 40 Y N 1 F N
+# pic_conso-rescue_Conn_01x05
+#
+DEF pic_conso-rescue_Conn_01x05 J 0 40 Y N 1 F N
 F0 "J" 0 300 50 H V C CNN
-F1 "Conn_01x05" 0 -300 50 H V C CNN
+F1 "pic_conso-rescue_Conn_01x05" 0 -300 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -191,9 +190,9 @@
 ENDDEF
 #
-# Conn_01x08
-#
-DEF Conn_01x08 J 0 40 Y N 1 F N
+# pic_conso-rescue_Conn_01x08
+#
+DEF pic_conso-rescue_Conn_01x08 J 0 40 Y N 1 F N
 F0 "J" 0 400 50 H V C CNN
-F1 "Conn_01x08" 0 -500 50 H V C CNN
+F1 "pic_conso-rescue_Conn_01x08" 0 -500 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -227,9 +226,9 @@
 ENDDEF
 #
-# Conn_02x01
-#
-DEF Conn_02x01 J 0 40 Y N 1 F N
+# pic_conso-rescue_Conn_02x01
+#
+DEF pic_conso-rescue_Conn_02x01 J 0 40 Y N 1 F N
 F0 "J" 50 100 50 H V C CNN
-F1 "Conn_02x01" 50 -100 50 H V C CNN
+F1 "pic_conso-rescue_Conn_02x01" 50 -100 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -251,9 +250,9 @@
 ENDDEF
 #
-# Conn_02x02_Odd_Even
-#
-DEF Conn_02x02_Odd_Even J 0 40 Y N 1 F N
+# pic_conso-rescue_Conn_02x02_Odd_Even
+#
+DEF pic_conso-rescue_Conn_02x02_Odd_Even J 0 40 Y N 1 F N
 F0 "J" 50 100 50 H V C CNN
-F1 "Conn_02x02_Odd_Even" 50 -200 50 H V C CNN
+F1 "pic_conso-rescue_Conn_02x02_Odd_Even" 50 -200 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -279,9 +278,9 @@
 ENDDEF
 #
-# Crystal_GND2
-#
-DEF Crystal_GND2 Y 0 40 Y N 1 F N
+# pic_conso-rescue_Crystal_GND2
+#
+DEF pic_conso-rescue_Crystal_GND2 Y 0 40 Y N 1 F N
 F0 "Y" 0 225 50 H V C CNN
-F1 "Crystal_GND2" 0 150 50 H V C CNN
+F1 "pic_conso-rescue_Crystal_GND2" 0 150 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -303,9 +302,9 @@
 ENDDEF
 #
-# D_Zener_Small
-#
-DEF D_Zener_Small D 0 10 N N 1 F N
+# pic_conso-rescue_D_Zener_Small
+#
+DEF pic_conso-rescue_D_Zener_Small D 0 10 N N 1 F N
 F0 "D" 0 90 50 H V C CNN
-F1 "D_Zener_Small" 0 -90 50 H V C CNN
+F1 "pic_conso-rescue_D_Zener_Small" 0 -90 50 H V C CNN
 F2 "" 0 0 50 V I C CNN
 F3 "" 0 0 50 V I C CNN
@@ -326,9 +325,9 @@
 ENDDEF
 #
-# GND
-#
-DEF GND #PWR 0 0 Y Y 1 F P
+# pic_conso-rescue_GND
+#
+DEF pic_conso-rescue_GND #PWR 0 0 Y Y 1 F P
 F0 "#PWR" 0 -250 50 H I C CNN
-F1 "GND" 0 -150 50 H V C CNN
+F1 "pic_conso-rescue_GND" 0 -150 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -339,9 +338,9 @@
 ENDDEF
 #
-# GNDA
-#
-DEF GNDA #PWR 0 0 Y Y 1 F P
+# pic_conso-rescue_GNDA
+#
+DEF pic_conso-rescue_GNDA #PWR 0 0 Y Y 1 F P
 F0 "#PWR" 0 -250 50 H I C CNN
-F1 "GNDA" 0 -150 50 H V C CNN
+F1 "pic_conso-rescue_GNDA" 0 -150 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -352,9 +351,9 @@
 ENDDEF
 #
-# GNDD
-#
-DEF GNDD #PWR 0 0 Y Y 1 F P
+# pic_conso-rescue_GNDD
+#
+DEF pic_conso-rescue_GNDD #PWR 0 0 Y Y 1 F P
 F0 "#PWR" 0 -250 50 H I C CNN
-F1 "GNDD" 0 -125 50 H V C CNN
+F1 "pic_conso-rescue_GNDD" 0 -125 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -366,9 +365,9 @@
 ENDDEF
 #
-# LED
-#
-DEF LED D 0 40 Y N 1 F N
+# pic_conso-rescue_LED
+#
+DEF pic_conso-rescue_LED D 0 40 Y N 1 F N
 F0 "D" 0 100 50 H V C CNN
-F1 "LED" 0 -100 50 H V C CNN
+F1 "pic_conso-rescue_LED" 0 -100 50 H V C CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -387,9 +386,9 @@
 ENDDEF
 #
-# LM285LP
-#
-DEF LM285LP U 0 40 N N 1 F N
+# pic_conso-rescue_LM285LP
+#
+DEF pic_conso-rescue_LM285LP U 0 40 N N 1 F N
 F0 "U" -100 100 60 H V C CNN
-F1 "LM285LP" -50 -100 60 H V C CNN
+F1 "pic_conso-rescue_LM285LP" -50 -100 60 H V C CNN
 F2 "" 0 0 60 H I C CNN
 F3 "" 0 0 60 H I C CNN
@@ -403,12 +402,11 @@
 ENDDEF
 #
-# LM7805CT
-#
-DEF LM7805CT U 0 40 Y Y 1 F N
+# pic_conso-rescue_LM7805CT
+#
+DEF pic_conso-rescue_LM7805CT U 0 40 Y Y 1 F N
 F0 "U" -200 200 50 H V C CNN
-F1 "LM7805CT" 0 200 50 H V L CNN
+F1 "pic_conso-rescue_LM7805CT" 0 200 50 H V L CNN
 F2 "TO-220" 0 100 50 H V C CIN
 F3 "" 0 0 50 H V C CNN
-ALIAS LM7806CT LM7808CT LM7809CT LM7810CT LM7812CT LM7815CT LM7818CT LM7824CT LM7806ACT LM7808ACT LM7809ACT LM7810ACT LM7812ACT LM7815ACT LM7818ACT LM7824ACT
 $FPLIST
  TO*
@@ -422,9 +420,9 @@
 ENDDEF
 #
-# MCP2200
-#
-DEF MCP2200 IC 0 40 Y Y 1 F N
+# pic_conso-rescue_MCP2200
+#
+DEF pic_conso-rescue_MCP2200 IC 0 40 Y Y 1 F N
 F0 "IC" 50 550 60 H V C CNN
-F1 "MCP2200" 0 -250 60 V V C CNN
+F1 "pic_conso-rescue_MCP2200" 0 -250 60 V V C CNN
 F2 "" 0 0 60 H I C CNN
 F3 "" 0 0 60 H I C CNN
@@ -432,14 +430,5 @@
 S -350 500 350 -500 0 1 0 N
 X Vdd 1 -650 450 300 R 50 50 1 1 W
-X OSC1 2 -650 350 300 R 50 50 1 1 B
-X OSC2 3 -650 250 300 R 50 50 1 1 B
-X RST 4 -650 150 300 R 50 50 1 1 B I
-X GP7 5 -650 50 300 R 50 50 1 1 B
-X GP6 6 -650 -50 300 R 50 50 1 1 B
-X GP5 7 -650 -150 300 R 50 50 1 1 B
-X GP4 8 -650 -250 300 R 50 50 1 1 B
-X GP3 9 -650 -350 300 R 50 50 1 1 B
 X Tx 10 -650 -450 300 R 50 50 1 1 B
-X Vss 20 650 450 300 L 50 50 1 1 B
 X RTS 11 650 -450 300 L 50 50 1 1 B I
 X Rx 12 650 -350 300 L 50 50 1 1 B
@@ -451,19 +440,46 @@
 X D- 18 650 250 300 L 50 50 1 1 B
 X D+ 19 650 350 300 L 50 50 1 1 B
-ENDDRAW
-ENDDEF
-#
-# PIC18F26J53
-#
-DEF PIC18F26J53 U 0 40 Y Y 1 F N
+X OSC1 2 -650 350 300 R 50 50 1 1 B
+X Vss 20 650 450 300 L 50 50 1 1 B
+X OSC2 3 -650 250 300 R 50 50 1 1 B
+X RST 4 -650 150 300 R 50 50 1 1 B I
+X GP7 5 -650 50 300 R 50 50 1 1 B
+X GP6 6 -650 -50 300 R 50 50 1 1 B
+X GP5 7 -650 -150 300 R 50 50 1 1 B
+X GP4 8 -650 -250 300 R 50 50 1 1 B
+X GP3 9 -650 -350 300 R 50 50 1 1 B
+ENDDRAW
+ENDDEF
+#
+# pic_conso-rescue_PIC18F27J53
+#
+DEF pic_conso-rescue_PIC18F27J53 U 0 40 Y Y 1 F N
 F0 "U" -700 950 50 H V L CNN
-F1 "PIC18F26J53" 700 950 50 H V R CNN
+F1 "pic_conso-rescue_PIC18F27J53" 700 950 50 H V R CNN
 F2 "" -500 -500 50 H V C CNN
 F3 "" 0 -50 50 H V C CNN
-ALIAS PIC18F27J53
 DRAW
 S -850 900 700 -600 0 1 10 f
 X ~MCLR~ 1 -950 750 100 R 50 50 1 1 I
+X RA6/OSC2/CLKOUT 10 -950 150 100 R 50 50 1 1 B
+X T1OSCO/RC0 11 -950 -50 100 R 50 50 1 1 B
+X T1OSCI/CCP8/RC1 12 -950 -150 100 R 50 50 1 1 B
+X RC2/AN11 13 -950 -250 100 R 50 50 1 1 B
+X Vusb 14 -150 -700 100 U 50 50 1 1 W
+X D-/RC4 15 800 0 100 L 50 50 1 1 B
+X D+/RC5 16 800 -100 100 L 50 50 1 1 B
+X TX1/RC6 17 800 -200 100 L 50 50 1 1 B
+X RX1/RC7 18 800 -300 100 L 50 50 1 1 B
+X Vss 19 -250 -700 100 U 50 50 1 1 W
 X RA0/AN0 2 -950 650 100 R 50 50 1 1 B
+X Vdd 20 100 -700 100 U 50 50 1 1 W
+X AN12/INT0/RB0 21 800 800 100 L 50 50 1 1 B
+X AN10/RB1 22 800 700 100 L 50 50 1 1 B
+X AN8/RB2 23 800 600 100 L 50 50 1 1 B
+X AN9/RB3 24 800 500 100 L 50 50 1 1 B
+X CCP4/RB4 25 800 400 100 L 50 50 1 1 B
+X CCP5/RB5 26 800 300 100 L 50 50 1 1 B
+X CCP6/PGC/RB6 27 800 200 100 L 50 50 1 1 B
+X CPP7/PGD/RB7 28 800 100 100 L 50 50 1 1 B
 X RA1/AN1 3 -950 550 100 R 50 50 1 1 B
 X RA2/Vref-AN2 4 -950 450 100 R 50 50 1 1 B
@@ -473,31 +489,12 @@
 X Vss 8 -350 -700 100 U 50 50 1 1 W
 X RA7/OSC1/CLKIN 9 -950 50 100 R 50 50 1 1 B
-X RA6/OSC2/CLKOUT 10 -950 150 100 R 50 50 1 1 B
-X Vdd 20 100 -700 100 U 50 50 1 1 W
-X T1OSCO/RC0 11 -950 -50 100 R 50 50 1 1 B
-X AN12/INT0/RB0 21 800 800 100 L 50 50 1 1 B
-X T1OSCI/CCP8/RC1 12 -950 -150 100 R 50 50 1 1 B
-X AN10/RB1 22 800 700 100 L 50 50 1 1 B
-X RC2/AN11 13 -950 -250 100 R 50 50 1 1 B
-X AN8/RB2 23 800 600 100 L 50 50 1 1 B
-X Vusb 14 -150 -700 100 U 50 50 1 1 W
-X AN9/RB3 24 800 500 100 L 50 50 1 1 B
-X D-/RC4 15 800 0 100 L 50 50 1 1 B
-X CCP4/RB4 25 800 400 100 L 50 50 1 1 B
-X D+/RC5 16 800 -100 100 L 50 50 1 1 B
-X CCP5/RB5 26 800 300 100 L 50 50 1 1 B
-X TX1/RC6 17 800 -200 100 L 50 50 1 1 B
-X CCP6/PGC/RB6 27 800 200 100 L 50 50 1 1 B
-X RX1/RC7 18 800 -300 100 L 50 50 1 1 B
-X CPP7/PGD/RB7 28 800 100 100 L 50 50 1 1 B
-X Vss 19 -250 -700 100 U 50 50 1 1 W
-ENDDRAW
-ENDDEF
-#
-# Q_NMOS_GSD
-#
-DEF Q_NMOS_GSD Q 0 0 Y N 1 F N
+ENDDRAW
+ENDDEF
+#
+# pic_conso-rescue_Q_NMOS_GSD
+#
+DEF pic_conso-rescue_Q_NMOS_GSD Q 0 0 Y N 1 F N
 F0 "Q" 200 50 50 H V L CNN
-F1 "Q_NMOS_GSD" 200 -50 50 H V L CNN
+F1 "pic_conso-rescue_Q_NMOS_GSD" 200 -50 50 H V L CNN
 F2 "" 200 100 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -526,9 +523,9 @@
 ENDDEF
 #
-# R_Small
-#
-DEF R_Small R 0 10 N N 1 F N
+# pic_conso-rescue_R_Small
+#
+DEF pic_conso-rescue_R_Small R 0 10 N N 1 F N
 F0 "R" 30 20 50 H V L CNN
-F1 "R_Small" 30 -40 50 H V L CNN
+F1 "pic_conso-rescue_R_Small" 30 -40 50 H V L CNN
 F2 "" 0 0 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -543,9 +540,9 @@
 ENDDEF
 #
-# Si4483
-#
-DEF Si4483 Q 0 0 Y N 1 F N
+# pic_conso-rescue_Si4483
+#
+DEF pic_conso-rescue_Si4483 Q 0 0 Y N 1 F N
 F0 "Q" 200 50 50 H V L CNN
-F1 "Si4483" 200 -50 50 H V L CNN
+F1 "pic_conso-rescue_Si4483" 200 -50 50 H V L CNN
 F2 "" 200 100 50 H I C CNN
 F3 "" 0 0 50 H I C CNN
@@ -582,12 +579,11 @@
 ENDDEF
 #
-# TLP2358
-#
-DEF TLP2358 U 0 40 Y Y 1 F N
+# pic_conso-rescue_TLP2358
+#
+DEF pic_conso-rescue_TLP2358 U 0 40 Y Y 1 F N
 F0 "U" -200 200 50 H V L CNN
-F1 "TLP2358" 0 200 50 H V L CNN
+F1 "pic_conso-rescue_TLP2358" 0 200 50 H V L CNN
 F2 "Housings_SOIC:SO-6_4.4x3.6mm_Pitch1.27mm" -200 -200 50 H I L CIN
 F3 "" 0 0 50 H I L CNN
-ALIAS 4N26 TIL111 4N27 4N28
 $FPLIST
  DIP*W7.62mm*
@@ -616,9 +612,9 @@
 ENDDEF
 #
-# USB_A-RESCUE-pic_conso
-#
-DEF USB_A-RESCUE-pic_conso P 0 40 Y Y 1 F N
+# pic_conso-rescue_USB_A-RESCUE-pic_conso
+#
+DEF pic_conso-rescue_USB_A-RESCUE-pic_conso P 0 40 Y Y 1 F N
 F0 "P" 200 -200 50 H V C CNN
-F1 "USB_A-RESCUE-pic_conso" -50 200 50 H V C CNN
+F1 "pic_conso-rescue_USB_A-RESCUE-pic_conso" -50 200 50 H V C CNN
 F2 "" -50 -100 50 V V C CNN
 F3 "" -50 -100 50 V V C CNN
@@ -640,9 +636,9 @@
 ENDDEF
 #
-# USB_B-RESCUE-pic_conso
-#
-DEF USB_B-RESCUE-pic_conso P 0 40 Y Y 1 F N
+# pic_conso-rescue_USB_B-RESCUE-pic_conso
+#
+DEF pic_conso-rescue_USB_B-RESCUE-pic_conso P 0 40 Y Y 1 F N
 F0 "P" 200 -200 50 H V C CNN
-F1 "USB_B-RESCUE-pic_conso" -50 200 50 H V C CNN
+F1 "pic_conso-rescue_USB_B-RESCUE-pic_conso" -50 200 50 H V C CNN
 F2 "" -50 -100 50 V V C CNN
 F3 "" -50 -100 50 V V C CNN
@@ -664,9 +660,9 @@
 ENDDEF
 #
-# VO1400AEFTR
-#
-DEF VO1400AEFTR U 0 40 Y N 1 L N
+# pic_conso-rescue_VO1400AEFTR
+#
+DEF pic_conso-rescue_VO1400AEFTR U 0 40 Y N 1 L N
 F0 "U" -200 320 50 H V L BNN
-F1 "VO1400AEFTR" -200 -400 50 H V L BNN
+F1 "pic_conso-rescue_VO1400AEFTR" -200 -400 50 H V L BNN
 F2 "SOIC254P695X242-4N" 0 0 50 H I L BNN
 F3 "SOP-4 Vishay" 0 0 50 H I L BNN